// Copyright (c) 2021 Visiosto oy
// Licensed under the MIT License
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
// Based on code by Chase Ohlson.
// Original code is available at https://github.com/brohlson/gatsby-plugin-anchor-links.
import React from 'react';
import { Link } from 'gatsby';
import handleLinkClick from './handleLinkClick';
import stripHashedLocation from './stripHashedLocation';
import handleStrippedLinkClick from './handleStrippedLinkClick';
function AnchorLink(_a) {
    var children = _a.children, _b = _a.className, className = _b === void 0 ? '' : _b, _c = _a.gatsbyLinkProps, gatsbyLinkProps = _c === void 0 ? {} : _c, _d = _a.onAnchorLinkClick, onAnchorLinkClick = _d === void 0 ? undefined : _d, _e = _a.stripHash, stripHash = _e === void 0 ? false : _e, to = _a.to;
    var handleClick = stripHash ? handleStrippedLinkClick : handleLinkClick;
    var linkProps = __assign(__assign({}, gatsbyLinkProps), { 
        /**
         * Spread optional gatsbyLinkProps object in fist, so our specific props will override
         */
        to: stripHash ? stripHashedLocation(to) : to, onClick: function (event) { return handleClick(to, event, onAnchorLinkClick); } });
    /**
     * Optional props
     */
    if (className !== '') {
        linkProps.className = className;
    }
    // TODO See if the props should be set without spreading
    // eslint-disable-next-line react/jsx-props-no-spreading
    return React.createElement(Link, __assign({}, linkProps), children);
}
export default AnchorLink;
