// Copyright (c) 2021 Visiosto oy
// Licensed under the MIT License
import './global';
import checkHash from './checkHash';
import scroller from './scroller';
// Based on code by Chase Ohlson.
// Original code is available at https://github.com/brohlson/gatsby-plugin-anchor-links.
// eslint-disable-next-line import/prefer-default-export
export var onRouteUpdate = function checkScrollOnRouteUpdate(_a, _b) {
    var location = _a.location;
    var _c = _b.offset, offset = _c === void 0 ? 0 : _c, _d = _b.duration, duration = _d === void 0 ? 1000 : _d;
    var isBrowser = typeof window !== 'undefined';
    var windowHash = isBrowser ? window.visiostoScrollHash : undefined;
    if (isBrowser) {
        window.visiostoScrollOffset = offset;
        window.visiostoScrollDuration = duration;
    }
    if (windowHash) {
        scroller(windowHash, offset);
    }
    else {
        checkHash(location, offset);
    }
    if (isBrowser && windowHash) {
        window.visiostoScrollHash = undefined;
    }
};
