// Copyright (c) 2021 Visiosto oy
// Licensed under the MIT License
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
// Based on code by Chase Ohlson.
// Original code is available at https://github.com/brohlson/gatsby-plugin-anchor-links.
import './global';
import { withPrefix } from 'gatsby';
import errorTypes from './errorTypes';
import logWarning from './logWarning';
import scroller from './scroller';
export default function handleLinkClick(to, event, onAnchorLinkClick) {
    /**
     * Log warnings on click
     */
    var improperFormatting = !to.includes('/') || !to.includes('#');
    if (improperFormatting) {
        logWarning(errorTypes.IMPROPPER_FORMATTING);
    }
    var isBrowser = typeof window !== 'undefined';
    if (isBrowser && to.includes('#')) {
        var _a = __read(to.split('#'), 2), anchorPath = _a[0], anchor = _a[1];
        if (window.location.pathname === withPrefix(anchorPath)) {
            event.preventDefault();
            scroller("#" + anchor, window.visiostoScrollOffset, window.visiostoScrollDuration);
        }
    }
    if (onAnchorLinkClick) {
        onAnchorLinkClick();
    }
}
